package models

import (
  "log"

  "gorm.io/gorm"
  "gorm.io/driver/sqlite"
)

var (
  DB *gorm.DB
)

// Initializes the Gorm database object
func Open() {
  // Initialize database object
  var err error
  DB, err = gorm.Open(sqlite.Open("data/blt.db"), &gorm.Config{})
  if err != nil {
    panic("Failed to connect database")
  }

  // Migrate the schema
  DB.AutoMigrate(&Project{}, &Hardware{}, &Benchmark{})
  log.Println("Database migrations complete.")
}

// Used to close the database connection; should be only called in main() as a deferral
func Close() error {
  return DB.Close()
}

